/*
Copyright 2012 Arun Kumar and Christopher Re

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

This work was supported by the Microsoft Jim Gray Systems Lab, 
the National Science Foundation and the Office of Naval Research.
*/
#ifndef PATH_H
#define PATH_H

#include "NodeEdge.h"
#include <string>

class Path {
private:
    string str;
    vector<EdgeWeight *> edges;
    double cost;

public:
    Path();
    Path(string,double);
    string getPath();

    int numOfEdges() const;
    string getPathStr() const;
    double getPathCost() const;
    EdgeWeight *getEdge(int);

    void appendEdge(EdgeWeight *);
    void appendPath(Path &);
    void appendPath(Path &, int, int);
    void setPathCost(double pathcost);
    void setPath(string);

    Path &operator=(const Path &);
    bool operator<(const Path& a);
};
enum ErrorType {FSTREADERROR,NOERROR,BUFFERNOTPOSINT,BUFFERTOOBIG,FSTMAXPATHEXCEED,FSTCONTAINCYCLE,FSTDISCONNECTED,INVALIDSTARTSTATENO,INVALIDENDSTATENO,ENDNOEXCEEDED };

static const double INF = 2e308;

#endif
