/*
Copyright 2012 Arun Kumar and Christopher Re

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

This work was supported by the Microsoft Jim Gray Systems Lab, 
the National Science Foundation and the Office of Naval Research.
*/
#include <iostream>
#include <fstream>
#include <string>
#include <cstring>
#include <cstdlib>
#include "libpq-fe.h"
using namespace std;

int main(int argc, char** argv) {
	if(argc < 7) {
		cout << "Usage: loadgraph <dbname> <port number> <staccatograph table> <docname> <mbinname> <.graph full filepath>\n";
		return 0;
	}
	PGconn* conn;
	string dbstring = "dbname=" +  string(argv[1]) + " port=" + string(argv[2]);
	conn = PQconnectdb(dbstring.c_str());
	if(PQstatus(conn) != CONNECTION_OK) {
		cout << "Error: Could not connect with " << dbstring << "! Message: " << PQerrorMessage(conn);
		PQfinish(conn);
		exit(1);
	}
	string docname = string(argv[4]);
	string fstname = string(argv[5]);
	string pathkey = docname + "-" + fstname;
	string gphname = string(argv[6]);
	string comndgph = "insert into " + string(argv[3]) + " values ('" + pathkey + "', lo_import('" + gphname.c_str() + "'));";
	PGresult *res;
	res = PQexec(conn, comndgph.c_str());
	PQclear(res);
	PQfinish(conn);	
return 0;
}
